#! @BASH@
#
echo 1..4 # Number of tests to be executed.
#
test -n "$CDO"      || CDO="@abs_top_builddir@/src/cdo $CDO_DEBUG"
test -n "$DATAPATH" || DATAPATH="@abs_top_srcdir@/test/data/"
#
HAS_THREADS=`${CDO} --config has-threads`
#
export CDO_FILE_SUFFIX=NULL
export CDO_WEIGHT_MODE=off
#
FORMAT="-f srv -b 32"
OPERATORS="eofcoeff eofcoeff3d"
#
NTEST=1
IFILE=$DATAPATH/psl_DJF_anom.grb
RFILE=$DATAPATH/pcoeff00000
OFILE=res_pcoeff
#
for OPERATOR in $OPERATORS; do
    for MODE in jacobi danielson_lanczos; do
        if [ "${HAS_THREADS}" = yes ] ; then
            RSTAT=0
            export CDO_SVD_MODE=$MODE

            CDOTEST="${OPERATOR} - $MODE"
            CDOCOMMAND="$CDO  $FORMAT ${OPERATOR} $DATAPATH/eof_ref $IFILE $OFILE"
            echo "$CDOCOMMAND"
        
            $CDOCOMMAND
            test $? -eq 0 || (( RSTAT+=1 ))
        
            $CDO  diff,abslim=0.02 -abs ${OFILE}00000 -abs $RFILE
            test $? -eq 0 || (( RSTAT+=1 ))
        
            test $RSTAT -eq 0 && echo "ok $NTEST - $CDOTEST"
            test $RSTAT -eq 0 || echo "not ok $NTEST - $CDOTEST"
        
            rm -f ${OFILE}00000
        else
            echo "ok $NTEST - $CDOTEST # SKIP POSIX threads not enabled"
        fi
        (( NTEST+=1 ))
    done
done
#
exit 0
